//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <dos.h>
#include <windows.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;
HINSTANCE hinstLib;
typedef int (*GETINT2PROC)(int, int*);
typedef int (*SETINT2PROC)(int, int);
typedef int (*GETUINTPROC)(unsigned int*);

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    AnsiString sVal;
    unsigned int IcId;
    GETUINTPROC ProcAdd;
    char *endptr;
    OpenDriverFail = 0;

    hinstLib = LoadLibrary("Fintek.dll");
    if (hinstLib == NULL)
    {
        ShowMessage("Load fail Fintek.dll");
        OpenDriverFail = 1;
    }

    ProcAdd = (GETUINTPROC) GetProcAddress(hinstLib, "GetNowICID");
    if (NULL != ProcAdd)
    {
        if (! (*ProcAdd)(&IcId))
        {
            ShowMessage("Read Fail");
        }
    }
    DeviceID = (USHORT)IcId;

    if ( OpenDriverFail == 0 )
    {
                TIniFile *ini;
                int iGpioReg=0, iOffset = 0, iGpioVal=0, iOutput_Mode=0;
                ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

                // gpio candidate. ref ic spec.
                for (iGpioReg=0x00; iGpioReg<=0x50; iGpioReg=iGpioReg+0x10)
                {
                    switch (iGpioReg)
                    {
                        case 0x00: iGpioVal = ini->ReadInteger( IntToHex(DeviceID, 4), "PinDefF0", 0 ); break;
                        case 0x10: iGpioVal = ini->ReadInteger( IntToHex(DeviceID, 4), "PinDefE0", 0 ); break;
                        case 0x20: iGpioVal = ini->ReadInteger( IntToHex(DeviceID, 4), "PinDefD0", 0 ); break;
                        case 0x30: iGpioVal = ini->ReadInteger( IntToHex(DeviceID, 4), "PinDefC0", 0 ); break;
                        case 0x40: iGpioVal = ini->ReadInteger( IntToHex(DeviceID, 4), "PinDefB0", 0 ); break;
                        case 0x50: iGpioVal = ini->ReadInteger( IntToHex(DeviceID, 4), "PinDefA0", 0 ); break;
                    }
                    for (iOffset=0; iOffset<=15; iOffset++)
                    {
                        if ((iGpioVal >> iOffset) & 0x01)
                        {
                            GP1ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP2ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP3ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP4ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP5ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP6ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP7ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                            GP8ComboBox->Items->Add(IntToHex(iOffset + iGpioReg, 2));
                        }
                    }
                }
                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO1", 0 );
                GP1ComboBox->Text = IntToHex(iOffset, 2);

                // GPIO1 Output Enable Register: read the INI value and write it into register
                sVal = "0x";
                sVal = sVal + GP1ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO1OE", 0 ) == 1)
                {
                        GP1CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP1CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO2", 0 );
                GP2ComboBox->Text = IntToHex(iOffset, 2);
                // GPIO2 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP2ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO2OE", 0 ) == 1)
                {
                        GP2CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP2CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO3", 0 );
                GP3ComboBox->Text = IntToHex(iOffset, 2);

                // GPIO3 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP3ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO3OE", 0 ) == 1)
                {
                        GP3CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP3CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO4", 0 );
                GP4ComboBox->Text = IntToHex(iOffset, 2);
                // GPIO4 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP4ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO4OE", 0 ) == 1)
                {
                        GP4CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP4CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO5", 0 );
                GP5ComboBox->Text = IntToHex(iOffset, 2);
                // GPIO5 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP5ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO5OE", 0 ) == 1)
                {
                        GP5CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP5CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO6", 0 );
                GP6ComboBox->Text = IntToHex(iOffset, 2);
                // GPIO6 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP6ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO6OE", 0 ) == 1)
                {
                        GP6CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP6CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO7", 0 );
                GP7ComboBox->Text = IntToHex(iOffset, 2);
                // GPIO7 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP7ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO7OE", 0 ) == 1)
                {
                        GP7CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP7CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }

                iOffset = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO8", 0 );
                GP8ComboBox->Text = IntToHex(iOffset, 2);
                // GPIO8 Output Enable Register
                sVal = "0x";
                sVal = sVal + GP8ComboBox->Text.c_str();
                if (ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO8OE", 0 ) == 1)
                {
                        GP8CheckBox->Checked = true;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                                case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                                case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                                case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                                case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                                case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                                case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                                case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                        }
                }
                else
                {
                        GP8CheckBox->Checked = false;
                        switch (StrToInt(sVal.c_str()) & 0x0F)
                        {
                                case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                                case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                                case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                                case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                                case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                                case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                                case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                                case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                        }
                }
                switch (StrToInt(sVal.c_str()) & 0xF0)
                {
                        case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                        case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                        case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                        case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                        case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                        case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
                }


      //---20120514 add ini output mode--------------
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO1Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP1RadioGroup->ItemIndex = 0;
      else
        GP1RadioGroup->ItemIndex = 1;

       WRITE_OutPutMode(1, GP1RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO2Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP2RadioGroup->ItemIndex = 0;
      else
        GP2RadioGroup->ItemIndex = 1;

       WRITE_OutPutMode(2, GP2RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO3Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP3RadioGroup->ItemIndex = 0;
      else
        GP3RadioGroup->ItemIndex = 1;

      WRITE_OutPutMode(3, GP3RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO4Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP4RadioGroup->ItemIndex = 0;
      else
        GP4RadioGroup->ItemIndex = 1;

      WRITE_OutPutMode(4, GP4RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO5Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP5RadioGroup->ItemIndex = 0;
      else
        GP5RadioGroup->ItemIndex = 1;

      WRITE_OutPutMode(5, GP5RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO6Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP6RadioGroup->ItemIndex = 0;
      else
        GP6RadioGroup->ItemIndex = 1;

      WRITE_OutPutMode(6, GP6RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO7Output_Mode", 0 );
      if(iOutput_Mode == 0)
        GP7RadioGroup->ItemIndex = 0;
      else
        GP7RadioGroup->ItemIndex = 1;

      WRITE_OutPutMode(7, GP7RadioGroup->ItemIndex);
//---
      iOutput_Mode = ini->ReadInteger( IntToHex(DeviceID, 4), "GPIO8Output_Mode", 0 );
       if(iOutput_Mode == 0)
        GP8RadioGroup->ItemIndex = 0;
      else
        GP8RadioGroup->ItemIndex = 1;

      WRITE_OutPutMode(8, GP8RadioGroup->ItemIndex);

      delete ini;
      Timer1->Enabled = true; 
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
    if( OpenDriverFail == 1 )
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    if (hinstLib != NULL)
    {
        FreeLibrary(hinstLib);
    }
}
//---------------------------------------------------------------------------

int __fastcall TForm1::READ_GPIO(int port)
{
        int data;
        GETINT2PROC ProcAdd;
        char *endptr;

        ProcAdd = (GETINT2PROC) GetProcAddress(hinstLib, "GPIO_LPC_R");
        if (NULL != ProcAdd)
        {
            if (! (*ProcAdd)(port, &data))
            {
	            ShowMessage("Read Fail");
            }
        }

        return data;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WRITE_GPIO(int port, int value)
{
        SETINT2PROC ProcAdd;
        char *endptr;

        ProcAdd = (SETINT2PROC) GetProcAddress(hinstLib, "GPIO_LPC_W");
        if (NULL != ProcAdd)
        {
                if (! (*ProcAdd)(port, value))
	        {
	            ShowMessage("Write Fail");
                }
        }
}
//---------------------------------------------------------------------------
    
void __fastcall TForm1::GP1ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP1ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO1", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP1CheckBox->Checked = true;
        else
                GP1CheckBox->Checked = false;

         delete ini;
}
//---------------------------------------------------------------------------
    
void __fastcall TForm1::GP1CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP1ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP1CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO1OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO1OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP2ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP2ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO2", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP2CheckBox->Checked = true;
        else
                GP2CheckBox->Checked = false;
         delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP3ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP3ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO3", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP3CheckBox->Checked = true;
        else
                GP3CheckBox->Checked = false;
         delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP4ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP4ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO4", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP4CheckBox->Checked = true;
        else
                GP4CheckBox->Checked = false;
         delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP5ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP5ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO5", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP5CheckBox->Checked = true;
        else
                GP5CheckBox->Checked = false;
         delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP6ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP6ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO6", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP6CheckBox->Checked = true;
        else
                GP6CheckBox->Checked = false;
         delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP7ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP7ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO7", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP7CheckBox->Checked = true;
        else
                GP7CheckBox->Checked = false;
         delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP8ComboBoxChange(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
         sVal = sVal + GP8ComboBox->Text.c_str();
         ini->WriteString( IntToHex(DeviceID, 4), "GPIO8", sVal );
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP8CheckBox->Checked = true;
        else
                GP8CheckBox->Checked = false;
         delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP2CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP2ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP2CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO2OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO2OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP3CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP3ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP3CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO3OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO3OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP4CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP4ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP4CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO4OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO4OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP5CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP5ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP5CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO5OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO5OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP6CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP6ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP6CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO6OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO6OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP7CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP7ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP7CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO7OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO7OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP8CheckBoxClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );
        sVal = sVal + GP8ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF0); break;
                case 0x10: iGpioVal = READ_GPIO(0xE0); break;
                case 0x20: iGpioVal = READ_GPIO(0xD0); break;
                case 0x30: iGpioVal = READ_GPIO(0xC0); break;
                case 0x40: iGpioVal = READ_GPIO(0xB0); break;
                case 0x50: iGpioVal = READ_GPIO(0xA0); break;
        }
        if (GP8CheckBox->Checked == true)
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO8OE", 1);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO8OE", 0);
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF0, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE0, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD0, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC0, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB0, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA0, iGpioVal); break;
        }

        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
         TIniFile *ini;
         int iGpioVal = 0;
         AnsiString sVal = "0x";
         Timer1->Enabled = false;
         ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

         sVal = "0x";
         sVal = sVal + GP1ComboBox->Text.c_str();
         switch (StrToInt(sVal.c_str()) & 0xF0)
         {
                case 0x00: iGpioVal = READ_GPIO(0xF2); break;
                case 0x10: iGpioVal = READ_GPIO(0xE2); break;
                case 0x20: iGpioVal = READ_GPIO(0xD2); break;
                case 0x30: iGpioVal = READ_GPIO(0xC2); break;
                case 0x40: iGpioVal = READ_GPIO(0xB2); break;
                case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP1Label->Caption = 1;
        else
                GP1Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP2ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP2Label->Caption = 1;
        else
                GP2Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP3ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP3Label->Caption = 1;
        else
                GP3Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP4ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP4Label->Caption = 1;
        else
                GP4Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP5ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP5Label->Caption = 1;
        else
                GP5Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP6ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP6Label->Caption = 1;
        else
                GP6Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP7ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP7Label->Caption = 1;
        else
                GP7Label->Caption = 0;

        sVal = "0x";
        sVal = sVal + GP8ComboBox->Text.c_str();
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
               case 0x00: iGpioVal = READ_GPIO(0xF2); break;
               case 0x10: iGpioVal = READ_GPIO(0xE2); break;
               case 0x20: iGpioVal = READ_GPIO(0xD2); break;
               case 0x30: iGpioVal = READ_GPIO(0xC2); break;
               case 0x40: iGpioVal = READ_GPIO(0xB2); break;
               case 0x50: iGpioVal = READ_GPIO(0xA2); break;
        }
        if (((iGpioVal >> (StrToInt(sVal.c_str()) & 0x0F)) & 0x01) == 0x01)
                GP8Label->Caption = 1;
        else
                GP8Label->Caption = 0;

        delete ini;
        Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP1SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0, iOutput_Mode = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP1ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP1RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }

            ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO1Output_Mode", 1);
        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
           ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO1Output_Mode", 0);
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP2SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP2ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP2RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
         ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO2Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
         ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO2Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP3SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP3ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP3RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO3Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO3Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP4SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP4ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP4RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO4Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO4Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP5SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP5ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP5RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }

          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO5Output_Mode", 1);
        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO5Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP6SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP6ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP6RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO6Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO6Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP7SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP7ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP7RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
           ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO7Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO7Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP8SetButtonClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP8ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP8RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO8Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO8Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------
void __fastcall  TForm1::WRITE_OutPutMode(int index, int mode)
{

        int iGpioVal = 0 ;
        AnsiString sVal , sVal1 = "0x", sVal2= "0x", sVal3= "0x", sVal4= "0x",
                   sVal5= "0x",sVal6= "0x",sVal7= "0x",sVal8= "0x";

        switch(index)
        {
          case 1: sVal1 = sVal1 + GP1ComboBox->Text.c_str(); sVal= sVal1 ; break;
          case 2: sVal2 = sVal2 + GP2ComboBox->Text.c_str(); sVal= sVal2 ; break;
          case 3: sVal3 = sVal3 + GP3ComboBox->Text.c_str(); sVal= sVal3 ; break;
          case 4: sVal4 = sVal4 + GP4ComboBox->Text.c_str(); sVal= sVal4 ; break;
          case 5: sVal5 = sVal5 + GP5ComboBox->Text.c_str(); sVal= sVal5 ; break;
          case 6: sVal6 = sVal6 + GP6ComboBox->Text.c_str(); sVal= sVal6 ; break;
          case 7: sVal7 = sVal7 + GP7ComboBox->Text.c_str(); sVal= sVal7 ; break;
          case 8: sVal8 = sVal8 + GP8ComboBox->Text.c_str(); sVal= sVal8 ; break;
        }

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (mode == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::GP1RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0, iOutput_Mode = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP1ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP1RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }

            ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO1Output_Mode", 1);
        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
           ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO1Output_Mode", 0);
        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP2RadioGroupClick(TObject *Sender)
{
      TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP2ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP2RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
         ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO2Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
         ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO2Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP3RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP3ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP3RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO3Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO3Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP4RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP4ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP4RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO4Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO4Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP5RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP5ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP5RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }

          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO5Output_Mode", 1);
        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO5Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP6RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP6ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP6RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO6Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO6Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP7RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP7ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP7RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
           ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO7Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO7Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GP8RadioGroupClick(TObject *Sender)
{
        TIniFile *ini;
        int iGpioVal = 0;
        AnsiString sVal = "0x";
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        sVal = sVal + GP8ComboBox->Text.c_str();

        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: iGpioVal = READ_GPIO(0xF1); break;
                case 0x10: iGpioVal = READ_GPIO(0xE1); break;
                case 0x20: iGpioVal = READ_GPIO(0xD1); break;
                case 0x30: iGpioVal = READ_GPIO(0xC1); break;
                case 0x40: iGpioVal = READ_GPIO(0xB1); break;
                case 0x50: iGpioVal = READ_GPIO(0xA1); break;
        }
        if (GP8RadioGroup->ItemIndex == 1)
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal | 0x01); break;
                        case 0x01: iGpioVal = (iGpioVal | 0x02); break;
                        case 0x02: iGpioVal = (iGpioVal | 0x04); break;
                        case 0x03: iGpioVal = (iGpioVal | 0x08); break;
                        case 0x04: iGpioVal = (iGpioVal | 0x10); break;
                        case 0x05: iGpioVal = (iGpioVal | 0x20); break;
                        case 0x06: iGpioVal = (iGpioVal | 0x40); break;
                        case 0x07: iGpioVal = (iGpioVal | 0x80); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO8Output_Mode", 1);

        }
        else
        {
                switch (StrToInt(sVal.c_str()) & 0x0F)
                {
                        case 0x00: iGpioVal = (iGpioVal & 0xFE); break;
                        case 0x01: iGpioVal = (iGpioVal & 0xFD); break;
                        case 0x02: iGpioVal = (iGpioVal & 0xFB); break;
                        case 0x03: iGpioVal = (iGpioVal & 0xF7); break;
                        case 0x04: iGpioVal = (iGpioVal & 0xEF); break;
                        case 0x05: iGpioVal = (iGpioVal & 0xDF); break;
                        case 0x06: iGpioVal = (iGpioVal & 0xBF); break;
                        case 0x07: iGpioVal = (iGpioVal & 0x7F); break;
                }
          ini->WriteInteger(IntToHex(DeviceID, 4), "GPIO8Output_Mode", 0);

        }
        switch (StrToInt(sVal.c_str()) & 0xF0)
        {
                case 0x00: WRITE_GPIO(0xF1, iGpioVal); break;
                case 0x10: WRITE_GPIO(0xE1, iGpioVal); break;
                case 0x20: WRITE_GPIO(0xD1, iGpioVal); break;
                case 0x30: WRITE_GPIO(0xC1, iGpioVal); break;
                case 0x40: WRITE_GPIO(0xB1, iGpioVal); break;
                case 0x50: WRITE_GPIO(0xA1, iGpioVal); break;
        }
        delete ini;        
}
//---------------------------------------------------------------------------

